<?php
/* $Id: function.inc.php,v 1.1 2006/06/06 08:55:03 volodya Exp $ */

#  
function cuttext($text, $numchar)
{
	$text=strip_tags($text);
	$text=htmlspecialchars($text);
	
	if (strlen($text)>$numchar)
	{
		$tmptext = strpos($text." "," ",$numchar);
		if ($tmptext != 0)
			$text=substr($text,0,$tmptext)."...";
	}
	return $text;
}


function istrpos($haystack,$needle,$offset = 0)
{
	setlocale (LC_ALL, array ('ru_RU.CP1251', 'rus_RUS.1251','russian'));
	return(strpos(strtolower($haystack),strtolower($needle),$offset));
}


function strpos_array($haystack, $needle)
{
  $kill = $offset = $i = 0;

  while ($kill === 0)
  {
    $i++;
    $result = strpos($haystack, $needle, $offset);

    if ($result === FALSE)
    {
      $kill = 1;
    }
    else
    {
      $array[$i] = $result;
      $offset = $result + 1;
    }
  }

  return $array;
}

function NC_CutWord($text, $first_or_last)
{
  $result = NULL;

  $tmp = explode(" ", $text);
  for ($i=0; $i<count($tmp); $i++)
  {
    if ($i == 0 && $first_or_last == 'first')
      continue;
    if ($i == (count($tmp) - 1) && $first_or_last == 'last')
      continue;
    $result .= $tmp[$i]." ";
  }

  return $result;
}

//      
function SearchTextEcho($text, $word)
{
  $mytext = "";
	$text = str_replace("&amp;", "&", $text);

	if ($word)
	{
		$tmptext = istrpos($text,$word);
		$word = substr($text,$tmptext,strlen($word));
		
		if ($tmptext !== FALSE)
		{
		  if ($tmptext >= 70)
		  {
		    $mytext = NC_CutWord(substr($text,$tmptext-70,70), 'first');
			  $mytext2 = NC_CutWord(substr($text,$tmptext+strlen($word),strlen($word)+70), 'last');
			  return "&#133; ".$mytext." <font style='background-color:#fbe99f;'>".$word."</font>".$mytext2." &#133;";
		  }
		  elseif ($tmptext < 70)
		  {
		    $mytext = substr($text,0,$tmptext);
			  $mytext2 = NC_CutWord(substr($text,$tmptext+strlen($word),strlen($word)+70), 'last');
			  return $mytext." <font style='background-color:#fbe99f;'>".$word."</font>".$mytext2." &#133;";
		  }
		}
	}

	return $mytext;
}


function FilterText ($text,$direction=1) 
{
	if ($direction==1)
	{
		$text=addslashes($text);
		$text=str_replace('$',"\\\\\\$",$text);
	}
	else
	{
		$text=stripslashes($text);
		$text=str_replace('\$',"$",$text);
	}

	return $text;
}
?>