<?php
/* $Id: function.inc.php,v 1.1 2006/06/06 08:55:03 volodya Exp $ */

function stats_Log()
{
    global $admin_mode;
    if ($admin_mode) return;

    global $db;
    global $HTTP_USER_AGENT;
    global $AUTH_USER_ID;
    global $REMOTE_ADDR;
    global $REMOTE_PORT;
    global $HTTP_REFERER;
    global $HTTP_HOST;
    global $HTTP_USER_AGENT;
    global $REQUEST_URI;
    global $REQUEST_METHOD;
    global $MODULE_VARS;
    global $e404_sub,$catalogue, $sub, $cc, $message, $action;

    if ($REQUEST_URI=="/favicon.ico" || $REQUEST_URI=="favicon.ico") {
        return;
    }

    if ($MODULE_VARS['stats']['INSTALLED'] != 1)
    {
        return;
    }

    $REMOTE_HOST = gethostbyaddr($REMOTE_ADDR);

    stats_SearchPhrases();

	//     /netcat/require/s_e404.inc.php
	$browser_name = array (
			'op' => 'Opera',
			'omni' => 'OmniWeb',
			'ie' => 'Internet Explorer',
			'konq' => 'Konqueror',
			'saf' => 'Safari',
			'moz' => 'Gecko',
			'rv' => 'Mozilla',
			'mozilla' => 'Mozilla',
			'firebird' => 'Firebird',
			'phoenix' => 'Phoenix',
			'firefox' => 'Firefox',
			'galeon' => 'Galeon',
			'k-meleon' => 'K-Meleon',
			'camino' => 'Camino',
			'epiphany' => 'Epiphany',
			'multizilla' => 'MultiZilla',
			'ns' => 'Netscape',
			'netscape6' => 'Netscape',
			'netscape' => 'Netscape',
			'lynx' => 'lynx',
			'w3m' => 'w3m',
			'amaya' => 'Amaya',
			'dillo' => 'Dillo',
			'ibrowse' => 'iBrowse',
			'icab' => 'iCab'
	);

	$os_name = array (
			'unixware' => 'UnixWare', 
			'solaris' => 'Solaris', 
			'sunos' => 'SunOS', 
			'sun4' => 'SunOS', 
			'sun5' => 'SunOS', 
			'suni86' => 'SunOS', 
			'sun' => 'SunOS', 
			'freebsd'  => 'FreeBSD', 
			'openbsd'  => 'OpenBSD', 
			'bsd' => 'BSD', 
			'irix5' => 'Irix', 
			'irix6' => 'Irix', 
			'irix' => 'Irix', 
			'hpux9' => 'HPUX', 
			'hpux10' => 'HPUX', 
			'hpux11' => 'HPUX', 
			'hpux' => 'HPUX', 
			'hp-ux' => 'HPUX',
			'aix1' => 'AIX', 
			'aix2' => 'AIX', 
			'aix3' => 'AIX', 
			'aix4' => 'AIX', 
			'aix5' => 'AIX', 
			'aix' => 'AIX', 
			'sco' => 'SCO', 
			'mpras' => 'MPRAS', 
			'reliant' => 'Reliant',
			'dec' => 'DEC', 
			'sinix' => 'Sinix', 
			'unix' => 'Unix',
			'kanotix' => 'Kanotix', 
			'ubuntu' => 'Ubuntu', 
			'mepis' => 'Mepis', 
			'debian' => 'Debian', 
			'suse' => 'Suse', 
			'redhat' => 'RedHat', 
			'slackware' => 'Slackware', 
			'mandrake' => 'Mandrake', 
			'gentoo' => 'Gentoo', 
			'linux' => 'Linux',
			'lin' => 'Linux',
			'beos' => 'BeOS', 
			'os2' => 'OS2', 
			'amiga' => 'Amiga', 
			'webtv' => 'WebTV', 
			'mac' => 'Mac', 
			'nt' => 'Windows', 
			'win' => 'Windows',
			'nt5.0' => 'Windows 2000',
			'nt5.1' => 'Windows XP',
			'nt5.2' => 'Windows Server 2003',
			'nt5' => 'Windows 2000',
			'nt4' => 'Windows NT',
			'nt3' => 'Windows NT',
			'win5.0' => 'Windows 2000',
			'win5.1' => 'Windows XP',
			'win5.2' => 'Windows Server 2003',
			'win4' => 'Windows NT',
			'win3' => 'Windows NT',
			'winme' => 'Windows ME',
			'winCE' => 'Windows CE',
	);

	$user_agent = browser_detection('full');
	$moz_version = browser_detection('moz_version');

	$user_os = browser_detection('os');
	$user_os_number = browser_detection('os_number');


	$real_browser = $moz_version[0]?$browser_name[$moz_version[0]]:$browser_name[$user_agent[0]];
	$real_browser_ver = $moz_version[0]?$moz_version[1]:$user_agent[1];
	$browser_info = $real_browser.' '.$real_browser_ver;

	$real_os = $os_name[$user_os.$user_os_number]?$os_name[$user_os.$user_os_number]:$user_os.' '.$user_os_number;

  	if ($real_browser && $sub!=$e404_sub)
    {
        stats_CreateReportGeo();

        $CookieID = $_COOKIE['CookieID'];
        $insert = "INSERT INTO 
						Stats_Log (
							Created, 
							User_ID, 
							REMOTE_ADDR, 
							REMOTE_HOST, 
							REMOTE_PORT, 
							HTTP_REFERER, 
							HTTP_HOST, 
							HTTP_USER_AGENT, 
							REQUEST_URI, 
							REQUEST_METHOD, 
							Browser,
							OS,
							Cookie_ID, 
							Catalogue_ID, 
							Subdivision_ID, 
							Sub_Class_ID, 
							Message_ID, 
							Action
						) 
					VALUES (
							NOW(), 
							'".$AUTH_USER_ID."', 
							'".$REMOTE_ADDR."', 
							'".$REMOTE_HOST."', 
							'".$REMOTE_PORT."', 
							'".$HTTP_REFERER."', 
							'".$HTTP_HOST."', 
							'".$HTTP_USER_AGENT."', 
							'".$REQUEST_URI."', 
							'".$REQUEST_METHOD."', 
							'".$browser_info."',
							'".$real_os."',
							'".$CookieID."', 
							'".$catalogue."', 
							'".$sub."', 
							'".$cc."', 
							'".$message."', 
							'".$action."'
						)
					";

        $db->query($insert);

        $LogID = $db->insert_id;

        if (!$CookieID)
        {
            $CookieID = md5(uniqid(rand(),true));

            setcookie("CookieID",$CookieID,time()+3600*24*365,"/",$HTTP_HOST);
            setcookie("LogID",$LogID,time()+3600*24*365,"/",$HTTP_HOST);
        }
        elseif ($CookieID && $LogID=$_COOKIE['LogID'])
        {
            $update = "UPDATE Stats_Log SET Cookie_ID='".$CookieID."',Created=Created WHERE Log_ID ='".$LogID."'";
            $db->query($update);
            setcookie("LogID","");
        }
    }
}

function stats_CreateReports()
{
    global $db;

    stats_CreateReportAttendance();
    stats_CreateReportPopularity();
    stats_CreateReportReferer();
    stats_CreateReportIP();
    stats_CreateReportBrowser();
    stats_CreateReportOS();

    $db->query("DELETE FROM Stats_Log WHERE Created < CURRENT_DATE()");
}

function stats_CreateReportAttendance()
{
    global $db;

    $db->query("DELETE FROM Stats_Attendance WHERE Date=CURRENT_DATE()");
    $db->query("INSERT IGNORE INTO 
					Stats_Attendance (
						Date,
						Hour,
						Hosts,
						Hits,
						Visitors,
						Catalogue_ID) 
				SELECT 
					DATE_FORMAT(Created,'%Y-%m-%d') AS Date,
					DATE_FORMAT(Created,'%H') AS Hour,
					COUNT(DISTINCT REMOTE_ADDR),
					COUNT(*),
					COUNT(DISTINCT REMOTE_ADDR,HTTP_USER_AGENT,Cookie_ID),
					Catalogue_ID 
				FROM 
					Stats_Log 
				GROUP BY Date,Hour,Catalogue_ID
				");

    $res = $db->get_results("SELECT 
								DATE_FORMAT(Created,'%Y-%m-%d') AS Date,
								DATE_FORMAT(Created,'%H') AS Hour,
								COUNT(DISTINCT REMOTE_ADDR),
								Catalogue_ID 
							FROM 
								Stats_Log 
							GROUP BY Date,REMOTE_ADDR,Catalogue_ID
							",ARRAY_N);
    if (!$count=$db->num_rows) return;

    for ($i=0;$i<$count;$i++) {
        list($date,$hour,$newhost,$cat_id) = $res[$i];
        $db->query("UPDATE 
						Stats_Attendance 
					SET 
						NewHosts=NewHosts+{$newhost} 
					WHERE 
						Catalogue_ID='{$cat_id}' 
					AND 
						Date='{$date}' 
					AND 
						Hour='{$hour}'
					");
    }

    $res = $db->get_results("SELECT 
								DATE_FORMAT(Created,'%Y-%m-%d') AS Date,
								DATE_FORMAT(Created,'%H') AS Hour,
								COUNT(DISTINCT REMOTE_ADDR,HTTP_USER_AGENT,Cookie_ID),
								Catalogue_ID 
							FROM 
								Stats_Log 
							GROUP BY Date,REMOTE_ADDR,HTTP_USER_AGENT,Cookie_ID,Catalogue_ID
							",ARRAY_N);
    if (!$count=$db->num_rows) return;

    for ($i=0;$i<$count;$i++) {
        list($date,$hour,$newvisitors,$cat_id) = $res[$i];
        $db->query("UPDATE Stats_Attendance SET NewVisitors=NewVisitors+".$newvisitors." WHERE Catalogue_ID='".$cat_id."' AND Date='".$date."' AND Hour=".$hour);
    }
}

function stats_CreateReportPopularity()
{
    global $db;

    $db->query("DELETE FROM Stats_Popularity WHERE Date=CURRENT_DATE()");
    $db->query("INSERT IGNORE INTO 
					Stats_Popularity (
						Date,
						Link,
						Hosts,
						Hits,
						Visitors,
						Catalogue_ID
					) 
				SELECT 
					DATE_FORMAT(Created,'%Y-%m-%d') AS Date, 
					CONCAT(HTTP_HOST,IF(RIGHT(CONCAT(IF(LOCATE('?',REQUEST_URI),'',REQUEST_URI),SUBSTRING(REQUEST_URI,1,LOCATE('?',REQUEST_URI)-1)),1)='/',LEFT(CONCAT(IF(LOCATE('?',REQUEST_URI),'',REQUEST_URI),SUBSTRING(REQUEST_URI,1,LOCATE('?',REQUEST_URI)-1)),LENGTH(CONCAT(IF(LOCATE('?',REQUEST_URI),'',REQUEST_URI),SUBSTRING(REQUEST_URI,1,LOCATE('?',REQUEST_URI)-1)))-1),CONCAT(IF(LOCATE('?',REQUEST_URI),'',REQUEST_URI),SUBSTRING(REQUEST_URI,1,LOCATE('?',REQUEST_URI)-1)))) AS Link,
					COUNT(DISTINCT REMOTE_ADDR),
					COUNT(*),
					COUNT(DISTINCT REMOTE_ADDR,HTTP_USER_AGENT,Cookie_ID),
					Catalogue_ID 
				FROM 
					Stats_Log 
				GROUP BY 
					Date,Link,Catalogue_ID
				");
}

function stats_CreateReportReferer()
{
    global $db;

    $db->query("DELETE FROM Stats_Referer WHERE Date=CURRENT_DATE()");
    $db->query("INSERT IGNORE INTO 
					Stats_Referer (
						Date,
						Referer,
						Hosts,
						Hits,
						Visitors,
						Catalogue_ID
					) 
				SELECT 
					DATE_FORMAT(Created,'%Y-%m-%d') AS Date,
					IF(LEFT(HTTP_REFERER,7)='http://',HTTP_REFERER,'') AS Referer,
					COUNT(DISTINCT REMOTE_ADDR),
					COUNT(*),
					COUNT(DISTINCT REMOTE_ADDR,HTTP_USER_AGENT,Cookie_ID),
					Catalogue_ID 
				FROM 
					Stats_Log 
				GROUP BY 
					Date,Referer,Catalogue_ID
				");
}

function stats_CreateReportIP()
{
    global $db;

    $db->query("DELETE FROM Stats_IP WHERE Date=CURRENT_DATE()");
    $db->query("INSERT IGNORE INTO 
					Stats_IP (
						Date,
						IP,
						Hits,
						Catalogue_ID
					) 
				SELECT 
					DATE_FORMAT(Created,'%Y-%m-%d') AS Date,
					REMOTE_ADDR AS IP,
					COUNT(*),
					Catalogue_ID 
				FROM 
					Stats_Log 
				GROUP BY 
					Date,IP,Catalogue_ID
				");
}

function stats_CreateReportBrowser()
{
    global $db;

	$db->query("DELETE FROM Stats_Browser WHERE Date=CURRENT_DATE()");

        $db->query("INSERT IGNORE INTO 
						Stats_Browser (
							Date,
							Browser,
							Visitors,
							Catalogue_ID
						) 
					SELECT 
						DATE_FORMAT(Created,'%Y-%m-%d') AS Date,
						Browser,
						COUNT(DISTINCT REMOTE_ADDR,HTTP_USER_AGENT,Cookie_ID),
						Catalogue_ID 
					FROM 
						Stats_Log 
					GROUP BY 
						Date,Browser,Catalogue_ID
					");
}

function stats_CreateReportOS()
{
    global $db;

	$db->query("DELETE FROM Stats_OS WHERE Date=CURRENT_DATE()");
        $s = "INSERT IGNORE INTO 
					Stats_OS (
						Date,
						OS,
						Visitors,
						Catalogue_ID
					) 
				SELECT 
					DATE_FORMAT(Created,'%Y-%m-%d') AS Date,
					OS,
					COUNT(DISTINCT REMOTE_ADDR,HTTP_USER_AGENT,Cookie_ID), 
					Catalogue_ID 
				FROM 
					Stats_Log 
				GROUP BY 
					Date,OS,Catalogue_ID
				";
        $db->query($s);

}

function stats_SearchPhrases()
{
    global $db, $HTTP_REFERER, $catalogue;

    $search_domains = array(0=>'www.yandex.ru', 'pda.yandex.ru', 'large.yandex.ru',
    'family.yandex.ru', 'www.rambler.ru', 'search.rambler.ru', 'sm.aport.ru',
    'go.mail.ru', 'search.msn.com', 'search.yahoo.com', 'www.altavista.com',
    'www.google.ru', 'www.google.com', 'www.alltheweb.com', 'yandex.ru');

    $search_queries = array(0=>'text', 'query', 'query', 'text', 'words', 'words',
    'r', 'q', 'q', 'p', 'q', 'q', 'q', 'q', 'text');

    $url = parse_url($HTTP_REFERER);
    if (!isset($url['host']) || !isset($url['query']))
    {
        return;
    }

    if (count($search_domains) != count($search_queries))
    {
        return;
    }

    for ($i=0; $i<count($search_domains); $i++)
    {
        $domain = $search_domains[$i];
        $query = $search_queries[$i];

        if ($domain == $url['host'])
        {
            $args = array();
            parse_str($url['query'], $args);

            if (isset($args[$query]) && strlen($args[$query]) > 0)
            {
                $now_date = date("Y-m-d");
                $search_phrase = urldecode($args[$query]);
                if ($i==13) // For AllTheWeb
                {
                    $search_phrase = html_entity_decode($search_phrase, ENT_QUOTES, "cp1251");
                }
                if ($i==11 || $i==12 || $i==10 || $i==8 || $i==9) // For Google, Altavista, MSN, Yahoo UTF-8
                {
                    //$search_phrase = iconv("UTF-8", "cp1251", $search_phrase);
                    $search_phrase = stats_EncodeUTF($search_phrase, "w");
                }
                $search_phrase = $db->escape($search_phrase);

                $q = $db->query("SELECT Hits FROM Stats_Phrases WHERE Date='$now_date' AND Phrase='$search_phrase' AND Catalogue_ID='$catalogue'");
                if ($db->num_rows == 0)
                {
                    // Insert new record
                    $db->query("INSERT INTO Stats_Phrases (Date, Phrase, Hits, Catalogue_ID) VALUES('$now_date', '$search_phrase', '1', '$catalogue')");
                }
                else
                {
                    // Update old record
                    $db->query("UPDATE Stats_Phrases SET Hits=Hits+1 WHERE Date='$now_date' AND Phrase='$search_phrase' AND Catalogue_ID='$catalogue'");
                }
            }
        }
    }
}

function stats_CreateReportGeo()
{
    global $catalogue, $db, $DOCUMENT_ROOT;

    if (!isset($_SERVER['REMOTE_ADDR']))
    return;

    $data_from = 0;
    $data_to = 100;

    $country = NULL;
    $remote_ip = floatval(sprintf("%u", ip2long($_SERVER['REMOTE_ADDR'])));

    // Exclude LAN address

    if ($remote_ip > floatval('167772160') && $remote_ip < floatval('184549375'))
    return;
    if ($remote_ip > floatval('2886729728') && $remote_ip < floatval('2887778303'))
    return;
    if ($remote_ip > floatval('3232235520') && $remote_ip < floatval('3232301055'))
    return;
    if ($_SERVER['REMOTE_ADDR'] == '127.0.0.1')
    return;

    for ($i=$data_from; $i<=$data_to; $i++)
    {
        if( ($fp = @fopen($DOCUMENT_ROOT."/netcat/modules/stats/data/$i.dat", 'r')) == FALSE )
        break;

        while (!feof($fp))
        {
            $buffer = trim(fgets($fp, 1024));
            if (strlen($buffer) > 0)
            {
                $ip_from = floatval(substr($buffer, 0, 10));
                $ip_to = floatval(substr($buffer, 10, 10));
                $country_name = substr($buffer, 20, 2);

                if ($remote_ip > $ip_from && $remote_ip < $ip_to)
                {
                    $country = $country_name;
                    break;
                }
            }
        }

        fclose($fp);

        if ($country != NULL)
        break;
    }

    if ($country != NULL)
    {
        $now_date = date("Y-m-d");

        $s = "SELECT Date, Country, Hits, Catalogue_ID FROM Stats_Geo ";
        $s .= "WHERE Date='$now_date' AND Country='$country' AND Catalogue_ID='$catalogue'";
        $q = $db->query($s);

        if ($db->num_rows != 0)
        {
            $s = "UPDATE Stats_Geo SET Hits=Hits+1 WHERE Date='$now_date'";
            $s .= " AND Country='$country' AND Catalogue_ID='$catalogue'";
            $db->query($s);
        }
        else
        {
            $s = "INSERT INTO Stats_Geo (Date, Country, Hits, Catalogue_ID) ";
            $s .= "VALUES ('$now_date', '$country', '1', '$catalogue')";
            $db->query($s);
        }
    }
}

function stats_EncodeUTF($str, $type)
{
    // $type:
    // 'w' - encodes from UTF to win
    // 'u' - encodes from win to UTF
    static $conv='';
    if (!is_array($conv))
    {
        $conv = array();
        for ($x=128; $x <=143; $x++)
        {
            $conv['utf'][]=chr(209).chr($x);
            $conv['win'][]=chr($x+112);
        }

        for ($x=144; $x <=191; $x++)
        {
            $conv['utf'][]=chr(208).chr($x);
            $conv['win'][]=chr($x+48);
        }

        $conv['utf'][]=chr(208).chr(129);
        $conv['win'][]=chr(168);
        $conv['utf'][]=chr(209).chr(145);
        $conv['win'][]=chr(184);
    }

    if ($type=='w')
    return str_replace($conv['utf'], $conv['win'], $str);
    elseif ($type=='u')
    return str_replace($conv['win'], $conv['utf'], $str);
    else
    return $str;
}

?>